environ_default = {
	'&ENVIRON': {
		'diffuse_layer': False,
		'environ_type': 'input',
		'verbose': 0,
		'environ_restart': False,
		'oldenviron': False,
		'environ_thr': 0.1,
		'environ_nskip': 1,
		'system_ntyp': 0,
		'system_dim': 0,
		'system_axis': 3,
		'env_electrostatic': True,
		'env_static_permittivity': 1.0,
		'env_optical_permittivity': 1.0,
		'env_surface_tension': 0.0,
		'env_pressure': 0.0,
		'env_external_charges': 0,
		'env_dielectric_regions': 0,
		'env_electrolyte_ntyp': 0,
		'stern_entropy': 'full',
		'cion': [],
		'cionmax': 0.0,
		'rion': 0.0,
		'zion': [],
		'solvent_temperature': 300.0,
		'add_jellium': False,
		'atomicspread': [],
		'electrolyte_linearized': False
	},
	'&BOUNDARY': {			
		'solvent_mode': 'electronic',
		'rhomax': 0.005,
		'rhomin': 0.0001,
		'tbeta': 4.8,
		'alpha': 1.0,
		'softness': 0.5,
		'field_awareness': 0.01,
		'charge_asymmetry': 0.0,
		'field_min': 10.0,
		'field_max': 12.0,
		'solvent_distance': 1.0,
		'solvent_spread': 0.5,
		'electrolyte_mode': 'electronic',
		'electrolyte_rhomax': 5e-3,
		'electrolyte_rhomin': 1e-4,
		'electrolyte_tbeta': 4.8,
		'electrolyte_alpha': 1.0,
		'electrolyte_softness': 0.5,
		'electrolyte_distance': 0.0,
		'electrolyte_spread': 0.5,
		'stype': 1,
		'radius_mode': 'uff',
		'solvationrad': [],
		'corespread': [],
		'solvent_radius': 0.0,
		'radial_scale': 2.0,
		'radial_spread': 0.5,
		'filling_threshold': 0.825,
		'filling_spread': 0.02,
		'boundary_core': 'analytic',
		'ifdtype': 1,
		'nfdpoint': 1
	},
	'&ELECTROSTATIC': {
		'problem': 'poisson',
		'solver': 'direct',
		'auxiliary': 'none',
		'tol': 1e-5,
		'mix': 0.5,
		'pbc_dim': 3,
		'pbc_axis': 3,
		'pbc_correction': 'none'
	}
}


typename = {
	"scf": "environ_scf",
	"relax": "environ_relax"
}